%define openwbemlocalstatedir %{_localstatedir}/lib

%define startnum 36
%define killnum 64
%define daemonname owcimomd
%define owversion 3.2.2

Name        	: openwbem
Version     	: %{owversion}
Release     	: 8%{?dist}
Group       	: Administration/System

Summary     	: The OpenWBEM CIMOM

License   		: BSD
URL         	: http://www.openwbem.org/
BuildRoot   	: %{_tmppath}/%{name}-%{version}

Source0: %{name}-%{version}.tar.bz2
Patch0: cmpi_c++wrapper.patch
Patch1: ax3_openwbem_conf.patch
Patch2: allow_anonymous_ro.patch
Patch3: openwbem_pamd.patch
Patch4: m4macro_define_underquoted.patch
Patch5: remove_wrong_error_log.patch

%package devel
Group           : Programming/Library
Summary         : Headers files for OpenWBEM
Requires	: openwbem

#%package doc
#Group           : Programming/Library
#Summary         : Documentation files for OpenWBEM

#%package perlNPI
#Group       	: Administration/System
#Summary     	: PerlNPI provider interface for the OpenWBEM CIMOM
#Requires	: openwbem, perl

%description
The OpenWBEM CIMOM

%description devel
Headers files for OpenWBEM

#%description doc
#Documentation files for OpenWBEM

#%description perlNPI
#PerlNPI provider interface for the OpenWBEM CIMOM

%prep

%setup 
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
#CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="" ./configure \
##	--prefix=%{prefix} \
#	--sysconfdir=/etc \
#	--localstatedir=%{localstatedir}
%configure --localstatedir=%{openwbemlocalstatedir}
make
#make docs

%Install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir} -p $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/daemons
install etc/sysconfig/daemons/owcimomd $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/daemons
install -d $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install etc/init/owcimomd $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/pam.d
install etc/pam.d/openwbem $RPM_BUILD_ROOT%{_sysconfdir}/pam.d

install -d $RPM_BUILD_ROOT%{_libdir}/openwbem/c++providers
install -d $RPM_BUILD_ROOT%{openwbemlocalstatedir}/openwbem

#fix /usr/lib/libowservicehttp.so since RPM can't.
#rm -f $RPM_BUILD_ROOT/%{prefix}/lib/libowservicehttp.so
#ln -s %{prefix}/lib/openwbem/services/libowservicehttp.so $RPM_BUILD_ROOT/%{prefix}/lib

#move the man pages into the correct spot
mkdir -p $RPM_BUILD_ROOT%{_mandir}
#mv $RPM_BUILD_ROOT/%{prefix}/man/* $RPM_BUILD_ROOT/%{_mandir}/

#rm -f $RPM_BUILD_ROOT/%{prefix}/lib/perl5/*/*/perllocal.pod

# Load the schema. 
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$RPM_BUILD_ROOT%{_libdir} \
    $RPM_BUILD_ROOT%{_bindir}/owmofc -c -n root/cimv2 \
    -d $RPM_BUILD_ROOT%{openwbemlocalstatedir}/openwbem \
    schemas/cim28/CIM_Schema28.mof mof/OpenWBEM_Interop.mof \
    mof/OpenWBEM_Acl1.0.mof


%Clean
%{__rm} -rf $RPM_BUILD_ROOT

%Post
# do followings if -i and not -U
if [ "$1" = "1" ]
then
ldconfig

#default not start

if [ -x /sbin/chkconfig ]; then
  /sbin/chkconfig --add %{daemonname}
  /sbin/chkconfig %{daemonname} off
else
  for i in 0 1 6
  do
    ln -sf ../init.d/%{daemonname} %{_sysconfdir}/rc.d/rc$i.d/K%{killnum}%{daemonname}
  done
  for i in 2 3 4 5
  do
    ln -sf ../init.d/%{daemonname} %{_sysconfdir}/rc.d/rc$i.d/K%{killnum}%{daemonname}
  done
fi

# create self-signed cert.
umask 077

if [ ! -f %{_sysconfdir}/openwbem/hostkey+cert.pem ] ; then
FQDN=`hostname --fqdn`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

cat << EOF | sh %{_sysconfdir}/openwbem/owgencert > /dev/null 2>&1
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

fi

%PreUn
# if -e operation, not -U 
if [ "$1" = "0" ]   
then
  # Stop the daemon
  /etc/rc.d/init.d/%{daemonname} stop
  if [ -x /sbin/chkconfig ]; then
    /sbin/chkconfig --del %{daemonname}
  else
    for i in 0 1 6
    do
      rm -f /etc/rc.d/rc$i.d/K%{killnum}%{daemonname}
    done
    for i in 2 3 4 5
    do
      rm -f /etc/rc.d/rc$i.d/S%{startnum}%{daemonname}
      rm -f /etc/rc.d/rc$i.d/K%{killnum}%{daemonname}
    done
  fi
fi

%PostUn
# if -e operation, not -U
if [ "$1" = "0" ]   
then
 ldconfig
fi

%Files
%defattr(-,root,root)
%doc README TODO AUTHORS COPYING ChangeLog INSTALL LICENSE
%doc doc/{*.HOWTO,*.txt,*.html,HowToCreateAMinimalOpenWBEM,OpenWBEM_Getting_Started_Guide.sxw,PerlIFC.sxw,pg.tex}
%dir %{_libdir}/openwbem
%{_libdir}/openwbem/*
%dir %{_libexecdir}/openwbem
%dir %{_datadir}/openwbem
%dir %{openwbemlocalstatedir}/openwbem
%dir %{_sysconfdir}/openwbem
%config %{_sysconfdir}/openwbem/*
%config %{_sysconfdir}/sysconfig/daemons/%{daemonname}
%config %{_sysconfdir}/pam.d/openwbem
%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/%{daemonname}
%{_libdir}/lib*
%{_bindir}/*
%{_sbindir}/*
%{_libexecdir}/openwbem/*
%{_datadir}/openwbem/*
%config(noreplace) %{openwbemlocalstatedir}/openwbem/*
%{_mandir}/man1/*
%{_mandir}/man8/*

%Files devel
%defattr(-,root,root)
%dir %{_includedir}/openwbem
%{_includedir}/openwbem/*
%{_datadir}/aclocal/openwbem.m4

#%Files doc
#%defattr(-,root,root)
#%doc docs/*

#%Files perlNPI
#%{prefix}/lib/perl5/site_perl
#%defattr(-,root,root)
#%{_mandir}/man3/*

%ChangeLog
* Tue Jul 29 2008 He Tao <taohe@redflag-linux.com> 3.2.2-8%{?dist}
- upgrade release number, just rebuild for maintance.

* Tue Jul 1 2008 He Tao <taohe@redflag-linux.com> 
- correct the install scripts in spec file.

* Wed May 21 2008 He Tao <taohe@redflag-linux.com> 3.2.2-6%{?dist}
- modify the patch ax3_openwbem_conf.patch to deny the anonymous by default.

* Tue Jul 3 2007 Diancheng Wang <dcwang@redflag-linux.com> 3.2.2-5
- add a patch, Removed an incorrect log message in CMPI provider interface.
- add a patch, Fix quoting of CHECK_OPENWBEM.

* Mon Jun 18 2007 Diancheng Wang <dcwang@redflag-linux.com> 3.2.2-4
- call "chkconfig --add" register itself to chkconfig, see refer to
- bug #2907

* Mon May 28 2007 Diancheng Wang <dcwang@redflag-linux.com> 3.2.2-3
- merge patch allow_local_authentication.patch and disable_http_listen.patch
- to ax3_openwbem_conf.patch, not start owcimomd service by default

* Wed May 23 2007 Diancheng Wang <dcwang@redflag-linux.com> 3.2.2-3
- add patch openwbem_pamd.patch, problem that on x86-64 platform 
- user cannot login fixed.

* Fri Apr 13 2007 Diancheng Wang <dcwang@redflag-linux.com>
- replace absolute paths with RPM macros, %{_libdir}, %{localstatedir}, etc.
- so now x64 platform libraries will be installed in /usr/lib64

* Mon Feb 12 2007 Pengcheng Zou <pczou@redflag-linux.com>
- initial build based on Diancheng's spec.

